varying mediump vec2 vTex;
uniform lowp sampler2D samplerFront;
uniform mediump vec2 srcStart;
uniform mediump vec2 srcEnd;
uniform lowp sampler2D samplerDepth;
uniform mediump vec2 destStart;
uniform mediump vec2 destEnd;
uniform mediump float zNear;
uniform mediump float zFar;

uniform mediump float falloff;
uniform mediump float focalPoint;
uniform mediump vec3 firstColor;
uniform mediump vec3 middleColor;
uniform mediump vec3 endColor;
uniform mediump float middleColorPosition;
uniform mediump float rmiddleColorPosition;
precision mediump float;


void main(void)
{
mediump float log2x = 1.442695;
mediump vec2 tex = (vTex - srcStart) / (srcEnd - srcStart);
mediump float depthSample = texture2D(samplerDepth, mix(destStart, destEnd, tex)).r;
mediump float zLinear = zNear * zFar / (zFar + depthSample * (zNear - zFar));
mediump float focDist = max(zLinear - focalPoint, 0.0);
mediump float blurFactor = clamp((1.0 - exp2(-falloff * falloff * focDist * focDist * log2x)), 0.0, 1.0);
mediump float colorPosition = clamp(blurFactor * (1. + middleColorPosition) - middleColorPosition, 0.0, 1.0);
vec4 front = texture2D(samplerFront, vTex);
float h = rmiddleColorPosition; 
vec3 col = mix(mix(firstColor, middleColor, colorPosition / h), mix(middleColor, endColor, (colorPosition - h)/(1.0 - h)), step(h, colorPosition));

gl_FragColor = mix(front, vec4(col * front.a, front.a), blurFactor);

}