﻿%%FRAGMENTINPUT_STRUCT%%

%%FRAGMENTOUTPUT_STRUCT%%

%%SAMPLERFRONT_BINDING%% var samplerFront : sampler;
%%TEXTUREFRONT_BINDING%% var textureFront : texture_2d<f32>;

%%SAMPLERDEPTH_BINDING%% var samplerDepth : sampler;
%%TEXTUREDEPTH_BINDING%% var textureDepth : texture_depth_2d;

struct ShaderParams {
	falloff : f32,
	focalPoint : f32,
	firstColor : vec3<f32>,
	middleColor : vec3<f32>,
	endColor : vec3<f32>,
	middleColorPosition : f32,
	rmiddleColorPosition : f32,
};

%%SHADERPARAMS_BINDING%% var<uniform> shaderParams : ShaderParams;

%%C3PARAMS_STRUCT%%

%%C3_UTILITY_FUNCTIONS%%

const log_2 = 1.442695;
@fragment
fn main(input : FragmentInput) -> FragmentOutput
{
var front : vec4<f32> = textureSample(textureFront, samplerFront, input.fragUV);
var depthSample : f32 = textureSample(textureDepth, samplerDepth, c3_getDepthUV(input.fragPos.xy, textureDepth));
var zLinear : f32 = c3_linearizeDepth(depthSample);
var fogDist = max(zLinear - shaderParams.focalPoint, 0.0);
var blurFactor : f32 = clamp(1.0 - exp2(-shaderParams.falloff * shaderParams.falloff * fogDist * fogDist * log_2), 0.0, 1.0);
var colorPosition : f32 = clamp(blurFactor * (1. + shaderParams.middleColorPosition) - shaderParams.middleColorPosition, 0.0, 1.0);

let h: f32 = shaderParams.rmiddleColorPosition;
let col: vec3<f32> = mix(mix(shaderParams.firstColor, shaderParams.middleColor, colorPosition / h), mix(shaderParams.middleColor, shaderParams.endColor, (colorPosition - h) / (1. - h)), step(h, colorPosition));

var output : FragmentOutput;
output.color = mix(front, vec4<f32>(col * front.a, front.a), blurFactor);
return output;
}